#include "stdafx.h"
#include "NeMessenger.h"
#include "ProfileDlg.h"
#include "NeMessengerDlg.h"
#include "resource.h"
#include "DialPadManager.h"
#include "SendNoteMananger.h"

#define PROFILE_IMAGE_WIDTH		88
#define PROFILE_IMAGE_HEIGHT	108

IMPLEMENT_DYNAMIC(CProfileDlg, CBaseDlgStyleOne)

CProfileDlg::CProfileDlg(CWnd* pParent /*=NULL*/)
	: CBaseDlgStyleOne(CProfileDlg::IDD, pParent)
{
	m_pProfileDlgController = NULL;
	m_pImageDownloadThread = NULL;
	m_hInternetSession = NULL;
	m_hHttpConnection = NULL;
	m_hHttpFile = NULL;
	m_bAbort = FALSE;
	m_bSafeToClose = FALSE;
	m_strID = _T("");
	m_strPartyID[0] = _T("");
	m_strPartyID[1] = _T("");
	m_trid = 0;
	m_nDlgID = 0;
	m_pWASActor = NULL;
	m_nCursor = CURSOR_DEFAULT;
	m_eIPTStatus = iptstNA;
	m_hBrushStatic = CreateSolidBrush(COLOR_NORMAL_BK);
}

CProfileDlg::~CProfileDlg()
{
	if (GET_APP()->IsAvailableIPT())
		m_ilIPTStatus.DeleteImageList();

	if (m_hBitmapNoImage)
		DeleteObject(m_hBitmapNoImage);

	if (m_hBrushStatic)
		DeleteObject(m_hBrushStatic);

	m_penBorder.DeleteObject();
	m_penImageBorder.DeleteObject();
}

void CProfileDlg::DoDataExchange(CDataExchange* pDX)
{
	CBaseDlgStyleOne::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PICTURE_STATIC, m_stPicture);

	DDX_Control(pDX, IDC_EDIT_NAME, m_editName);
	DDX_Control(pDX, IDC_EDIT_PART, m_editPart);
	DDX_Control(pDX, IDC_EDIT_POSITION, m_editPosition);
	DDX_Control(pDX, IDC_EDIT_WORKSTATUS, m_editWorkstatus);
	DDX_Control(pDX, IDC_EDIT_EXTTEL, m_editExttel);
	DDX_Control(pDX, IDC_EDIT_TEL, m_editTel);
	DDX_Control(pDX, IDC_EDIT_MOBILE, m_editMobile);
	DDX_Control(pDX, IDC_EDIT_FAX, m_editFax);
	DDX_Control(pDX, IDC_EDIT_EMAIL, m_editEmail);
	DDX_Control(pDX, IDC_EDIT_ROMINGTEL, m_editRomingtel);
	DDX_Control(pDX, IDC_EDIT_CITY, m_editCity);
	DDX_Control(pDX, IDC_EDIT_KEYWORD, m_editKeyword);

	DDX_Control(pDX, IDC_PARTY1_STATIC, m_staticParty[0]);
	DDX_Control(pDX, IDC_PARTY2_STATIC, m_staticParty[1]);	
	DDX_Control(pDX, IDC_PARTY1_CHAT, m_btnPartyChat[0]);
	DDX_Control(pDX, IDC_PARTY2_CHAT, m_btnPartyChat[1]);
	DDX_Control(pDX, IDC_PARTY1_NOTE, m_btnPartyNote[0]);
	DDX_Control(pDX, IDC_PARTY2_NOTE, m_btnPartyNote[1]);

	DDX_Control(pDX, IDOK, m_btnOK);
}


BEGIN_MESSAGE_MAP(CProfileDlg, CBaseDlgStyleOne)	
	ON_WM_PAINT()	
	ON_WM_DESTROY()
	ON_WM_CTLCOLOR()
	ON_WM_MOUSEMOVE()
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDOWN()
	ON_MESSAGE(WM_HTTPDOWNLOAD_THREAD_FINISHED, OnThreadFinished)
	ON_BN_CLICKED(IDOK, &CProfileDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_PARTY1_CHAT, &CProfileDlg::OnBnClickedParty1Chat)
	ON_BN_CLICKED(IDC_PARTY2_CHAT, &CProfileDlg::OnBnClickedParty2Chat)
	ON_BN_CLICKED(IDC_PARTY1_NOTE, &CProfileDlg::OnBnClickedParty1Note)
	ON_BN_CLICKED(IDC_PARTY2_NOTE, &CProfileDlg::OnBnClickedParty2Note)
	ON_STN_CLICKED(IDC_PARTY1_STATIC, &CProfileDlg::OnStnClickedParty1Static)
	ON_STN_CLICKED(IDC_PARTY2_STATIC, &CProfileDlg::OnStnClickedParty2Static)
END_MESSAGE_MAP()

void CALLBACK CProfileDlg::_OnStatusCallBack(HINTERNET hInternet, DWORD_PTR dwContext, DWORD dwInternetStatus, 
											 LPVOID lpvStatusInformation, DWORD dwStatusInformationLength)
{
	switch (dwInternetStatus)
	{
	case INTERNET_STATUS_RESOLVING_NAME:
		{
			TRACE(_T("INTERNET_STATUS_RESOLVING_NAME\n"));    
			break;
		}
	case INTERNET_STATUS_NAME_RESOLVED:
		{
			TRACE(_T("INTERNET_STATUS_NAME_RESOLVED\n"));    
			break;
		}
	case INTERNET_STATUS_CONNECTING_TO_SERVER:
		{
			TRACE(_T("INTERNET_STATUS_CONNECTING_TO_SERVER\n"));    
			break;
		}
	case INTERNET_STATUS_CONNECTED_TO_SERVER:
		{
			TRACE(_T("INTERNET_STATUS_CONNECTED_TO_SERVER\n"));    
			break;
		}
	case INTERNET_STATUS_REDIRECT:
		{
			TRACE(_T("INTERNET_STATUS_REDIRECT\n"));    
			break;
		}
	case INTERNET_STATUS_REQUEST_SENT:
		{
			TRACE(_T("INTERNET_STATUS_REQUEST_SENT\n"));    
			break;
		}
	case INTERNET_STATUS_REQUEST_COMPLETE:
		{
			TRACE(_T("INTERNET_STATUS_REQUEST_COMPLETE\n"));    
			break;
		}
	default:
		{
			break;
		}
	}
}

void CProfileDlg::CloseAllInternetHandle()
{
	if (m_hHttpFile != NULL)
	{
		InternetCloseHandle(m_hHttpFile);
		m_hHttpFile = NULL;
	}

	if (m_hHttpConnection != NULL)
	{
		InternetCloseHandle(m_hHttpConnection);
		m_hHttpConnection = NULL;
	}

	if (m_hInternetSession != NULL)
	{
		InternetCloseHandle(m_hInternetSession);
		m_hInternetSession = NULL;
	}

	m_FileToWrite.Close();
}

void CProfileDlg::DownloadThread()
{
	//Create the Internet session handle
	ASSERT(m_hInternetSession == NULL);
	m_hInternetSession = ::InternetOpen(AfxGetAppName(), INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);

	if (m_hInternetSession == NULL)
	{
		TRACE(_T("Failed in call to InternetOpen, Error:%d\n"), ::GetLastError());    
		CloseAllInternetHandle();
		return;
	}

	//Should we exit the thread
	if (m_bAbort)
	{
		PostMessage(WM_HTTPDOWNLOAD_THREAD_FINISHED);
		CloseAllInternetHandle();
		return;
	}  

	//Setup the status callback function
	if (::InternetSetStatusCallback(m_hInternetSession, _OnStatusCallBack) == INTERNET_INVALID_STATUS_CALLBACK)
	{
		TRACE(_T("Failed in call to InternetSetStatusCallback, Error:%d\n"), ::GetLastError());   
		CloseAllInternetHandle();
		return;
	}

	//Should we exit the thread
	if (m_bAbort)
	{
		PostMessage(WM_HTTPDOWNLOAD_THREAD_FINISHED);
		CloseAllInternetHandle();
		return;
	}  

	//Make the connection to the HTTP server          
	ASSERT(m_hHttpConnection == NULL);
	m_hHttpConnection = ::InternetConnect(m_hInternetSession, m_sServer, m_nPort, _T(""), _T(""), m_dwServiceType, 0, (DWORD_PTR)this);
	
	if (m_hHttpConnection == NULL)
	{
		TRACE(_T("Failed in call to InternetConnect, Error:%d\n"), ::GetLastError());    
		CloseAllInternetHandle();
		return;
	}

	//Should we exit the thread
	if (m_bAbort)
	{
		PostMessage(WM_HTTPDOWNLOAD_THREAD_FINISHED);
		CloseAllInternetHandle();
		return;
	}

	ASSERT(m_hHttpFile == NULL);
	m_hHttpFile = ::HttpOpenRequest(m_hHttpConnection, _T("GET"), m_sObject, NULL, NULL, NULL, INTERNET_FLAG_RELOAD | INTERNET_FLAG_DONT_CACHE, (DWORD_PTR)this);
	
	if (m_hHttpFile == NULL)
	{
		TRACE(_T("Failed in call to HttpOpenRequest, Error:%d\n"), ::GetLastError());    
		CloseAllInternetHandle();
		return;
	}

	//Should we exit the thread
	if (m_bAbort)
	{
		PostMessage(WM_HTTPDOWNLOAD_THREAD_FINISHED);
		CloseAllInternetHandle();
		return;
	}  

	//label used to jump to if we need to resend the request
resend:

	//Issue the request
	BOOL bSend = ::HttpSendRequest(m_hHttpFile, NULL, 0, NULL, 0);
	if (!bSend)
	{
		TRACE(_T("Failed in call to HttpSendRequest, Error:%d\n"), ::GetLastError());    
		CloseAllInternetHandle();
		return;
	}

	//Check the HTTP status code
	TCHAR szStatusCode[32] = {0,};
	DWORD dwInfoSize = 32;

	if (!::HttpQueryInfo(m_hHttpFile, HTTP_QUERY_STATUS_CODE, szStatusCode, &dwInfoSize, NULL))
	{
		TRACE(_T("Failed in call to HttpQueryInfo for HTTP query status code, Error:%d\n"), ::GetLastError());    
		CloseAllInternetHandle();
		return;
	}
	else
	{
		long nStatusCode = _ttol(szStatusCode);

		//Handle any authentication errors
		if (nStatusCode == HTTP_STATUS_PROXY_AUTH_REQ || nStatusCode == HTTP_STATUS_DENIED)
		{
			// We have to read all outstanding data on the Internet handle
			// before we can resubmit request. Just discard the data.
			char szData[51];
			DWORD dwSize;
			do
			{
				::InternetReadFile(m_hHttpFile, (LPVOID)szData, 50, &dwSize);
			}
			while (dwSize != 0);

			//Bring up the standard authentication dialog
			if (::InternetErrorDlg(GetSafeHwnd(), m_hHttpFile, ERROR_INTERNET_INCORRECT_PASSWORD, FLAGS_ERROR_UI_FILTER_FOR_ERRORS |
				FLAGS_ERROR_UI_FLAGS_GENERATE_DATA | FLAGS_ERROR_UI_FLAGS_CHANGE_OPTIONS, NULL) == ERROR_INTERNET_FORCE_RETRY)
				goto resend;
		}
		else if (nStatusCode != HTTP_STATUS_OK)
		{
			TRACE(_T("Failed to retrieve a HTTP 200 status, Status Code:%d\n"), nStatusCode);      
			CloseAllInternetHandle();
			return;
		}
	}

	// Get the length of the file.
	TCHAR szContentLength[32] = {0,};
	dwInfoSize = 32;
	DWORD dwFileSize = 0;
	BOOL bGotFileSize = FALSE;
	if (::HttpQueryInfo(m_hHttpFile, HTTP_QUERY_CONTENT_LENGTH, szContentLength, &dwInfoSize, NULL))
	{
		//Set the progress control range
		bGotFileSize = TRUE;
		dwFileSize = (DWORD) _ttol(szContentLength);    
	}
	else
	{
		TRACE(_T("Failed to HttpQueryInfo\n"));      
		CloseAllInternetHandle();
		return;
	}

	//Now do the actual read of the file
	DWORD dwBytesRead = 0;
	char szReadBuf[10240];
	DWORD dwBytesToRead = 10240;
	do
	{
		if (!::InternetReadFile(m_hHttpFile, szReadBuf, dwBytesToRead, &dwBytesRead))
		{
			TRACE(_T("Failed in call to InternetReadFile, Error:%d\n"), ::GetLastError());      
			CloseAllInternetHandle();
			return;
		}
		else if (dwBytesRead && !m_bAbort)
		{
			//Write the data to file
			TRY
			{
				m_FileToWrite.Write(szReadBuf, dwBytesRead);
			}
			CATCH(CFileException, e);                                          
			{
				TRACE(_T("An exception occured while writing to the download file\n"));        
				CloseAllInternetHandle();
				return;
			}
			END_CATCH

		}
	} 
	while (dwBytesRead && !m_bAbort);

	CloseAllInternetHandle();

	//We're finished
	PostMessage(WM_HTTPDOWNLOAD_THREAD_FINISHED);
}

LRESULT CProfileDlg::OnThreadFinished(WPARAM wParam, LPARAM /*lParam*/)
{
	//It's now safe to close since the thread has signaled us
	m_bSafeToClose = TRUE;

	//If an error occured display the message box
	if (!m_bAbort && !wParam)
	{
		DrawProfileImage(m_sFilename);
	}

	::DeleteFile(m_sFilename);
	return 0L;
}

void CProfileDlg::DrawProfileImage(CString &strImageFilePath)
{
	Image imgProfile(strImageFilePath);

	Bitmap bmpProfile(PROFILE_IMAGE_WIDTH, PROFILE_IMAGE_HEIGHT, PixelFormat32bppARGB);
	Graphics grpPhoto(&bmpProfile);

	RectF rcResize = GetFitSizeInRect(SizeF(PROFILE_IMAGE_WIDTH, PROFILE_IMAGE_HEIGHT), SizeF((Gdiplus::REAL)(imgProfile.GetWidth()), (Gdiplus::REAL)(imgProfile.GetHeight())));

	grpPhoto.DrawImage(&imgProfile, rcResize);

	HBITMAP hBmp;
	bmpProfile.GetHBITMAP(Gdiplus::Color(255, 255, 255), &hBmp);
	m_stPicture.SetBitmap(hBmp);
	DeleteObject(hBmp);
}

RectF CProfileDlg::GetFitSizeInRect(const SizeF &sizeMax, const SizeF &sizeOrg)
{
	REAL fRatioW = sizeMax.Width / sizeOrg.Width;
	REAL fRatioH = sizeMax.Height / sizeOrg.Height;

	REAL fRatioResize = 1.0;
	if( fRatioW > fRatioH )
		fRatioResize = fRatioH;
	else
		fRatioResize = fRatioW;

	RectF rcResize;
	rcResize.Width = sizeOrg.Width * fRatioResize;
	rcResize.Height = sizeOrg.Height * fRatioResize;
	rcResize.X = (sizeMax.Width - rcResize.Width) / 2;
	rcResize.Y = (sizeMax.Height - rcResize.Height) / 2;

	return rcResize;
}

BOOL CProfileDlg::OnInitDialog()
{
	CBaseDlgStyleOne::OnInitDialog();

	//g_pMessengerActor->RegisterObserver(this);
	m_pWASActor = g_pMessengerActor->GetWASActor();
	m_pWASActor->RegisterObserver(this);

	//vector<wstring> vecUsers;
	//vecUsers.push_back(m_strID.GetBuffer());
	//g_pMessengerActor->RequestRegiFavoriteToPOI(vecUsers, REGPOIGROUP_PROFILEDLG + m_nDlgID);

	ModifyStyle(0, WS_CLIPCHILDREN);
	SetWindowText(LoadStringFromResource(IDS_STRING281));

	InitControls();
	__ResourceLoad(TRUE);

	// â ũ   ġ ProfileDlgController  Ѵ.

	RequestInfo();

	return TRUE;
}

BOOL CProfileDlg::Create(LPCTSTR pszID, int nDlgID, CWnd* pParentWnd, CProfileDlgController* pProfileDlgController)
{
	m_strID = pszID;
	m_nDlgID = nDlgID;
	m_pProfileDlgController = pProfileDlgController;

	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);
	m_strMyID = myUserData.strUserID;

	return CBaseDlgStyleOne::Create(IDD, pParentWnd);
}

void CProfileDlg::InitControls()
{
	//  (, ̸, Ҽ, å, )
	m_stPicture.MoveWindow(20 - FRAME_WIDTH, 35, PROFILE_IMAGE_WIDTH, PROFILE_IMAGE_HEIGHT);
	m_editName.MoveWindow(210 - FRAME_WIDTH, 35, 250, 15);
	m_editPart.MoveWindow(210 - FRAME_WIDTH, 77, 250, 15);
	m_editPosition.MoveWindow(210 - FRAME_WIDTH, 101, 250, 15);
	m_editWorkstatus.MoveWindow(210 - FRAME_WIDTH, 125, 250, 15);

	m_editName.SetFont(&g_ftDefault9PTB);
	m_editPart.SetFont(&g_ftDefault9PT);
	m_editPosition.SetFont(&g_ftDefault9PT);
	m_editWorkstatus.SetFont(&g_ftDefault9PT);

	// ϴ (̸, ȸȭ, ޴,  )
	m_editExttel.MoveWindow(80 - FRAME_WIDTH, 168 + 25, 140, 15);
	m_editTel.MoveWindow(310, 168 + 25, 130, 15);
	m_editMobile.MoveWindow(80 - FRAME_WIDTH, 168 + 50, 140, 15);
	m_editFax.MoveWindow(310, 168 + 50, 160, 15);
	m_editEmail.MoveWindow(80 - FRAME_WIDTH, 168 + 75, 380, 15);

	m_editRomingtel.MoveWindow(80 - FRAME_WIDTH, 168 + 110, 170, 15);
	m_editCity.MoveWindow(310, 168 + 110, 160, 15);
	m_editKeyword.MoveWindow(80 - FRAME_WIDTH, 168 + 160, 380, 30);

	m_rtIPT[PD_IPT_EXT_TEL].SetRectEmpty();
	m_rtIPT[PD_IPT_INCO_TEL].SetRectEmpty();
	m_rtIPT[PD_IPT_CELLPHONE].SetRectEmpty();

	m_editEmail.SetFont(&g_ftDefault9PT);
	m_editTel.SetFont(&g_ftDefault9PT);
	m_editMobile.SetFont(&g_ftDefault9PT);
	m_editFax.SetFont(&g_ftDefault9PT);
	m_editExttel.SetFont(&g_ftDefault9PT);
	m_editRomingtel.SetFont(&g_ftDefault9PT);
	m_editCity.SetFont(&g_ftDefault9PT);
	m_editKeyword.SetFont(&g_ftDefault9PT);

	//  
	m_staticParty[0].MoveWindow(80 - FRAME_WIDTH, 168 + 135, 55, 15);
	m_btnPartyChat[0].MoveWindow(146 - FRAME_WIDTH, 168 + 135, 20, 15);
	m_btnPartyNote[0].MoveWindow(186 - FRAME_WIDTH, 168 + 135, 20, 15);

	m_staticParty[1].MoveWindow(240 - FRAME_WIDTH, 168 + 135, 55, 15);
	m_btnPartyChat[1].MoveWindow(296 - FRAME_WIDTH, 168 + 135, 20, 15);
	m_btnPartyNote[1].MoveWindow(316 - FRAME_WIDTH, 168 + 135, 20, 15);

	m_staticParty[0].SetFont(&g_ftDefault9PT);
	m_staticParty[0].SetColors(RGB(34,34,34), RGB(34,34,34), RGB(34,34,34));
	m_staticParty[0].EnableShellExecute(false);
	//m_staticParty[0].SetUnderline(true);
	m_staticParty[0].EnableToolTips(true);
	m_staticParty[0].SetTipText(LoadStringFromResource(IDS_STRING281));
	m_staticParty[0].SetURL(_T(""));	// SetURLԼ ȿ  ϱ   URL ȣ

	m_staticParty[1].SetFont(&g_ftDefault9PT);
	m_staticParty[1].SetColors(RGB(34,34,34), RGB(34,34,34), RGB(34,34,34));
	m_staticParty[1].EnableShellExecute(false);
	//m_staticParty[1].SetUnderline(true);
	m_staticParty[1].EnableToolTips(true);
	m_staticParty[1].SetTipText(LoadStringFromResource(IDS_STRING281));
	m_staticParty[1].SetURL(_T(""));

	m_btnOK.MoveWindow(200, 390, 80, 30);
	m_btnOK.SetFont(&g_ftDefault9PT);
	m_btnOK.SetWindowText(LoadStringFromResource(IDS_STRING565));

	// â  
	m_penBorder.CreatePen(PS_SOLID, 1, COLOR_LIST_BORDER);
	m_penImageBorder.CreatePen(PS_SOLID, 1, COLOR_IMAGE_BORDER);

	// ⺻ ̹
	m_hBitmapNoImage = LoadImageFromPath(GetAppImgFile(_T("NoImage.bmp")));

	if (m_hBitmapNoImage)
	{
		m_stPicture.SetBitmap(m_hBitmapNoImage);
	}

	m_tooltipKeyword.Create(this);
	m_tooltipEmail.Create(this);

	m_hLinkCursor = AfxGetApp()->LoadStandardCursor(IDC_HAND);

	if( GET_APP()->IsAvailableIPT() )
	{
		// Ʈ  IPT  ̹ Ʈ
		if (m_ilIPTStatus.Create(18, 18, ILC_COLOR32 | ILC_COLOR | ILC_MASK, 12, 3))
		{
			COLORREF crMask = RGB(0, 0, 0);

			const BYTE nStatusCnt = 9;
			for( BYTE i = 0; i < nStatusCnt; i++ )
			{
				CString strImageFilePath = GET_APP()->GetBuddyIPTPresenceImageFilePath( (NTIPTStatusType)i);

				CBitmap bmStatus;
				LoadBitmapFromPath(bmStatus, strImageFilePath);
				m_ilIPTStatus.Add(&bmStatus, crMask);
				bmStatus.DeleteObject();
			}
		}
	}
}

void CProfileDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	NMMemDC memDC;
	memDC.CreateCompatibleDC(&dc, &rcClient);
	memDC.FillSolidRect(0, 0, rcClient.Width(), rcClient.Height(), COLOR_NORMAL_BK);	// ȭ 

	CPen *pOldPen = memDC.SelectObject(&m_penBorder);
	memDC.SelectObject((HBRUSH)GetStockObject(NULL_BRUSH));

	//  μ
	memDC.MoveTo(0, 0);
	memDC.LineTo(rcClient.right, 0);

	// ߰ μ
	memDC.MoveTo(20 - FRAME_WIDTH, 168);
	memDC.LineTo(rcClient.right - 20 - FRAME_WIDTH, 168);

	// ϴ μ
	memDC.MoveTo(0, rcClient.bottom - 48);
	memDC.LineTo(rcClient.right, rcClient.bottom - 48);

	CRect rcImage(0, 0, 0, 0);
	m_stPicture.GetWindowRect(&rcImage);
	this->ScreenToClient(rcImage);
	rcImage.InflateRect(1, 1, 1, 1);
	memDC.SelectObject(&m_penImageBorder);
	memDC.Rectangle(rcImage);

	// ⺻ ؽƮ
	CFont *pOldFont = memDC.SelectObject(&g_ftDefault9PTB);
	memDC.SetTextColor(COLOR_STATIC_TEXT);
	memDC.SetBkMode(TRANSPARENT);

	// 
	memDC.DrawText(LoadStringFromResource(IDS_STRING142), CRect(118 - FRAME_WIDTH, 35, 210, 50), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);
	memDC.DrawText(LoadStringFromResource(IDS_STRING143), CRect(118 - FRAME_WIDTH, 77, 210, 100), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);
	memDC.DrawText(LoadStringFromResource(IDS_STRING147), CRect(118 - FRAME_WIDTH, 101, 210, 125), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);
	memDC.DrawText(LoadStringFromResource(IDS_STRING279), CRect(118 - FRAME_WIDTH, 125, 210, 150), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);

	// ϴ
	memDC.DrawText(LoadStringFromResource(IDS_STRING270), CRect(20 - FRAME_WIDTH, 168 + 25, 70, 168 + 49), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);	// ȣ
	memDC.DrawText(LoadStringFromResource(IDS_STRING271), CRect(250, 168 + 25, 310, 168 + 49), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);				// ȸȭ
	memDC.DrawText(LoadStringFromResource(IDS_STRING272), CRect(20 - FRAME_WIDTH, 168 + 50, 70, 168 + 74), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);	// ޴
	memDC.DrawText(LoadStringFromResource(IDS_STRING273), CRect(250, 168 + 50, 310, 168 + 74), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);				// ѽ
	memDC.DrawText(LoadStringFromResource(IDS_STRING274), CRect(20 - FRAME_WIDTH, 168 + 75, 70, 168 + 99), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);	// ̸

	memDC.DrawText(LoadStringFromResource(IDS_STRING275), CRect(20 - FRAME_WIDTH, 168 + 110, 70, 168 + 134), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);	// ι
	memDC.DrawText(LoadStringFromResource(IDS_STRING277), CRect(250, 168 + 110, 310, 168 + 134), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);				// 
	memDC.DrawText(LoadStringFromResource(IDS_STRING280), CRect(20 - FRAME_WIDTH, 168 + 135, 320, 168 + 159), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);	// 
	memDC.DrawText(LoadStringFromResource(IDS_STRING276), CRect(20 - FRAME_WIDTH, 168 + 160, 320, 168 + 184), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);	// Ű

	if( GET_APP()->IsAvailableIPT() )
	{
		// IPT  ׸
		CPoint ptImg(0, 0);

		if (!m_rtIPT[PD_IPT_EXT_TEL].IsRectEmpty())
		{
			ptImg.SetPoint(m_rtIPT[PD_IPT_EXT_TEL].left, m_rtIPT[PD_IPT_EXT_TEL].top);
			m_ilIPTStatus.Draw(&memDC, (int)m_eIPTStatus, ptImg, ILD_TRANSPARENT);
		}

		if (!m_rtIPT[PD_IPT_INCO_TEL].IsRectEmpty())
		{
			ptImg.SetPoint(m_rtIPT[PD_IPT_INCO_TEL].left, m_rtIPT[PD_IPT_INCO_TEL].top);
			m_ilIPTStatus.Draw(&memDC, (int)m_eIPTStatus, ptImg, ILD_TRANSPARENT);
		}

		if (!m_rtIPT[PD_IPT_CELLPHONE].IsRectEmpty())
		{
			ptImg.SetPoint(m_rtIPT[PD_IPT_CELLPHONE].left, m_rtIPT[PD_IPT_CELLPHONE].top);
			m_ilIPTStatus.Draw(&memDC, (int)m_eIPTStatus, ptImg, ILD_TRANSPARENT);
		}
	}

	// memDC  ׸  ѹ DC ׷  .
	dc.BitBlt(0, 0, rcClient.Width(), rcClient.Height(), &memDC, 0, 0, SRCCOPY);

	memDC.SelectObject(pOldPen);
	memDC.SelectObject(pOldFont);
}

bool CProfileDlg::OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID)
{
	if (m_trid != trid)	//   trid  ƴϸ true Ͽ   óϵ ش.
		return true;

	if (eErrorCode != wasError_None)
		return false;

	if (list.nSize <= 0)
		return false;

	const NE_MEMBER_DATA &sMemberInfo = list.pList[0];
	m_userData = sMemberInfo;

	CString strText;

	// ̸
	strText.Format(_T("%s"), sMemberInfo.strName.c_str());
	m_editName.SetWindowText(strText);

	// ̸(ٱ)
	strText.Format(_T("%s, %s, %s, %s"), sMemberInfo.strNameUS.c_str(), sMemberInfo.strNameTW.c_str(), sMemberInfo.strNameJP.c_str(), sMemberInfo.strNameCN.c_str());

	// Ҽ
	strText.Format(_T("%s"), sMemberInfo.strDept.c_str());
	m_editPart.SetWindowText(strText);

	// /å
	strText.Format(_T("%s/%s"), sMemberInfo.strJobPos.c_str(), sMemberInfo.strJobDuty.c_str());
	m_editPosition.SetWindowText(strText);

	//  
	if (m_strID == m_strMyID || GET_CONFIG()->EnableFunction(_T("UI_01")) == TRUE)
	{
		strText.Format(_T("%s"), sMemberInfo.strWorkStatus.c_str());
		m_editWorkstatus.SetWindowText(strText);
	}

	// ̸
	strText.Format(_T("%s"), sMemberInfo.strEmail.c_str());
	m_editEmail.SetWindowText(strText);

	CDC *pDC = m_editEmail.GetWindowDC();
	CSize szEmail = pDC->GetTextExtent(strText);
	ReleaseDC(pDC);

	CRect rtEmail(0, 0, 0, 0);
	m_editEmail.GetWindowRect(&rtEmail);

	// ̸ ̰    ߰
	if (szEmail.cx >= rtEmail.Width())
		m_tooltipEmail.AddTool(&m_editEmail, strText);

	//  ȣ
	strText.Format(_T("%s"), sMemberInfo.strExtesion.c_str());
	m_editExttel.SetWindowText(strText);

	if (!strText.IsEmpty())
	{
		CRect rtStatic(0, 0, 0, 0);
		m_editExttel.GetWindowRect(&rtStatic);
		ScreenToClient(&rtStatic);

		pDC = m_editExttel.GetWindowDC();
		CSize szText = pDC->GetTextExtent(strText);
		ReleaseDC(pDC);

		rtStatic.right = rtStatic.left + szText.cx + 10;
		m_editExttel.MoveWindow(&rtStatic);
		m_rtIPT[PD_IPT_EXT_TEL].SetRect(rtStatic.right, rtStatic.top, rtStatic.right + 18, rtStatic.top + 18);
	}

	// ȸ ȣ
	strText.Format(_T("%s"), sMemberInfo.strIncoTel.c_str());
	m_editTel.SetWindowText(strText);

	if (!strText.IsEmpty())
	{
		CRect rtStatic(0, 0, 0, 0);
		m_editTel.GetWindowRect(&rtStatic);
		ScreenToClient(&rtStatic);

		pDC = m_editTel.GetWindowDC();
		CSize szText = pDC->GetTextExtent(strText);
		ReleaseDC(pDC);

		rtStatic.right = rtStatic.left + szText.cx + 10;
		m_editTel.MoveWindow(&rtStatic);
		m_rtIPT[PD_IPT_INCO_TEL].SetRect(rtStatic.right, rtStatic.top, rtStatic.right + 18, rtStatic.top + 18);
	}

	// ޴
	strText.Format(_T("%s"), sMemberInfo.strCellPhone.c_str());
	m_editMobile.SetWindowText(strText);

	if (!strText.IsEmpty())
	{
		CRect rtStatic(0, 0, 0, 0);
		m_editMobile.GetWindowRect(&rtStatic);
		ScreenToClient(&rtStatic);

		pDC = m_editMobile.GetWindowDC();
		CSize szText = pDC->GetTextExtent(strText);
		ReleaseDC(pDC);

		rtStatic.right = rtStatic.left + szText.cx + 10;
		m_editMobile.MoveWindow(&rtStatic);
		m_rtIPT[PD_IPT_CELLPHONE].SetRect(rtStatic.right, rtStatic.top, rtStatic.right + 18, rtStatic.top + 18);
	}

	// ѽ ȣ
	strText.Format(_T("%s"), sMemberInfo.strFaxNum.c_str());
	m_editFax.SetWindowText(strText);

	// ι
	strText.Format(_T("%s"), sMemberInfo.strRmngPhone.c_str());
	m_editRomingtel.SetWindowText(strText);

	// Ű
	strText.Format(_T("%s"), sMemberInfo.strKeyword.c_str());
	m_editKeyword.SetWindowText(strText);

	pDC = m_editKeyword.GetWindowDC();
	CSize szKeyword = pDC->GetTextExtent(strText);
	ReleaseDC(pDC);

	CRect rtKeyword(0, 0, 0, 0);
	m_editKeyword.GetWindowRect(&rtKeyword);

	// Ṵ̋    ߰
	if (szKeyword.cx >= rtKeyword.Width())
		m_tooltipKeyword.AddTool(&m_editKeyword, strText);

	// 
	strText.Format(_T("%s"), sMemberInfo.strWorkPlace.c_str());
	m_editCity.SetWindowText(strText);

	if (sMemberInfo.strPhotoURL.empty() != true && (m_strID == m_strMyID || GET_CONFIG()->EnableFunction(_T("UI_02")) == TRUE))
	{
		DownloadPicture(sMemberInfo.strPhotoURL.c_str());
	}

	//  
	strText.Format(_T("%s"), sMemberInfo.strAddInfoCont.c_str());
	if (!strText.IsEmpty())
	{
		vector<CString> vecParty;
		SplitString(strText, _T(','), vecParty);
		if( vecParty.empty() )	// ڰ 1  SplitString NULL Ѿ´.
			vecParty.push_back(strText);

		for (DWORD i = 0; i < vecParty.size(); i++)
		{
			if (i >= MAX_PARTY_NUM)
				break;

			int nFind = vecParty[i].Find(_T("|"));
			CString strName = vecParty[i].Left(nFind);
			CString strID = vecParty[i].Mid(nFind + 1);

			m_staticParty[i].SetWindowText(strName);
			m_strPartyID[i] = strID;

			pDC = m_staticParty[i].GetWindowDC();
			CSize szPary = pDC->GetTextExtent(strName);
			ReleaseDC(pDC);

			CRect rtName(0, 0, 0, 0);
			m_staticParty[i].GetWindowRect(&rtName);
			ScreenToClient(&rtName);
			rtName.right = rtName.left + szPary.cx + 2;
			m_staticParty[i].MoveWindow(&rtName);

			CRect rtChat(0, 0, 0, 0);
			m_btnPartyChat[i].GetWindowRect(&rtChat);
			ScreenToClient(&rtChat);
			rtChat.MoveToX(rtName.right + 3);
			m_btnPartyChat[i].MoveWindow(&rtChat);

			CRect rtNote(0, 0, 0, 0);
			m_btnPartyNote[i].GetWindowRect(&rtNote);
			ScreenToClient(&rtNote);
			rtNote.MoveToX(rtChat.right + 3);
			m_btnPartyNote[i].MoveWindow(&rtNote);

			m_staticParty[i].ShowWindow(SW_SHOW);
			m_btnPartyNote[i].ShowWindow(SW_SHOW);
			m_btnPartyChat[i].ShowWindow(SW_SHOW);
		}
	}
		
	return false;
}

void CProfileDlg::OnDestroy()
{	
	//g_pMessengerActor->RequestUregFavoriteFromPOI(REGPOIGROUP_PROFILEDLG + m_nDlgID);
	//g_pMessengerActor->UnRegisterObserver(this);

	if (m_pWASActor)
		m_pWASActor->UnRegisterObserver(this);

	__super::OnDestroy();
}

void CProfileDlg::OnBnClickedParty1Chat()
{
	std::vector<wstring> vecUsers;
	vecUsers.push_back(m_strPartyID[0].GetString());

	g_pMessengerActor->RequestGetBuddyStatus(vecUsers);
}

void CProfileDlg::OnBnClickedParty2Chat()
{
	std::vector<wstring> vecUsers;
	vecUsers.push_back(m_strPartyID[1].GetString());

	g_pMessengerActor->RequestGetBuddyStatus(vecUsers);
}

void CProfileDlg::SentNote(CString strReceiverID, CString strReceiverName)
{
	std::vector<ReceiverInfo> receiverVector;
	ReceiverInfo receiverInfo;

	receiverInfo.strID = strReceiverID;
	receiverInfo.strName = strReceiverName;
	receiverVector.push_back(receiverInfo);

	GET_APP()->m_pSendNoteManager->CreateReceiverInfoListNote(receiverVector);
}

void CProfileDlg::OnBnClickedParty1Note()
{
	CString strPartyName;
	m_staticParty[0].GetWindowText(strPartyName);
	SentNote(m_strPartyID[0], strPartyName);
}

void CProfileDlg::OnBnClickedParty2Note()
{
	CString strPartyName;
	m_staticParty[1].GetWindowText(strPartyName);
	SentNote(m_strPartyID[1], strPartyName);
}

void CProfileDlg::RequestInfo(void)
{
	m_pWASActor->RequestEmplyeeInfo(m_strID, GetLanguageStringUnicode(), reitSingleTrans, &m_trid);
}

BOOL CProfileDlg::PreTranslateMessage(MSG* pMsg)
{
	if (IsCloseMsg(pMsg))
	{
		OnBnClickedOk();
		return TRUE;
	}

	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_ESCAPE)
		{
			OnBnClickedOk();
			return TRUE;
		}
		else if (pMsg->wParam == VK_RETURN)
		{
			return TRUE;
		}
	}

	m_tooltipKeyword.RelayEvent(pMsg);
	m_tooltipEmail.RelayEvent(pMsg);

	return __super::PreTranslateMessage(pMsg);
}

void CProfileDlg::OnBnClickedOk()
{
	/*  ٿε 尡 ϶ ȭڸ  CloseAllInternetHandle() 
	   ߸  ġ Ͽ ũð ߻ϹǷ,   Ȯ  ȭڰ  Ѵ. */
	if (m_pImageDownloadThread != NULL)
	{
		m_bAbort = TRUE;

		if (WaitForSingleObject(m_pImageDownloadThread->m_hThread, 3000) == WAIT_TIMEOUT)
		{
			// ŸӾƿ   
			TerminateThread(m_pImageDownloadThread->m_hThread, 0);
			Sleep(0);
		}
	}

	m_pProfileDlgController->CloseDlg(GetID(), m_nDlgID);
}

void CProfileDlg::__ResourceLoad(BOOL bInit)
{
	if (bInit)
	{
		m_btnPartyChat[0].SetBtnBitmapFile(GetAppImgFile(_T("ic_chat.bmp")), RGB(0,0,0));
		m_btnPartyChat[0].EnableHandCursor(TRUE);
		m_btnPartyChat[0].SetToolTipText(LoadStringFromResource(IDS_STRING252));

		m_btnPartyChat[1].SetBtnBitmapFile(GetAppImgFile(_T("ic_chat.bmp")), RGB(0,0,0));
		m_btnPartyChat[1].EnableHandCursor(TRUE);
		m_btnPartyChat[1].SetToolTipText(LoadStringFromResource(IDS_STRING252));

		m_btnPartyNote[0].SetBtnBitmapFile(GetAppImgFile(_T("ic_message.bmp")), RGB(0,0,0));
		m_btnPartyNote[0].EnableHandCursor(TRUE);
		m_btnPartyNote[0].SetToolTipText(LoadStringFromResource(IDS_STRING_MAIN_NOTE));

		m_btnPartyNote[1].SetBtnBitmapFile(GetAppImgFile(_T("ic_message.bmp")), RGB(0,0,0));
		m_btnPartyNote[1].EnableHandCursor(TRUE);
		m_btnPartyNote[1].SetToolTipText(LoadStringFromResource(IDS_STRING_MAIN_NOTE));
	}
	else
	{
		SendMessage(WM_SIZE, NULL, NULL);
	}
}

HBRUSH CProfileDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CBaseDlgStyleOne::OnCtlColor(pDC, pWnd, nCtlColor);	

	if (pWnd->GetDlgCtrlID() == IDC_STATIC_EMAIL)
	{
		pDC->SetBkColor(COLOR_NORMAL_BK);
		pDC->SetBkMode(TRANSPARENT);
		
		return m_hBrushStatic;
	}

	return hbr;
}

void CProfileDlg::SetReadOnly(BOOL bReadOnly)
{
	Invalidate();
}

//  ٿεϱ
void CProfileDlg::DownloadPicture(CString strURL)
{	
	if (!AfxParseURL(strURL, m_dwServiceType, m_sServer, m_sObject, m_nPort))
	{
		//Try sticking "http://" before it
		strURL = _T("http://") + strURL;
		if (!AfxParseURL(strURL, m_dwServiceType, m_sServer, m_sObject, m_nPort))
		{
			TRACE(_T("Failed to parse the URL: %s\n"), strURL);

			return ;
		}
	}

	TCHAR lpTempPathBuffer[MAX_PATH];
	GetTempPath(MAX_PATH, lpTempPathBuffer);

	TCHAR szTempFileName[MAX_PATH];
	GetTempFileName(lpTempPathBuffer, TEXT("tmpntk"), 0, szTempFileName);
	m_sFilename = (LPTSTR)szTempFileName;

	if (!m_FileToWrite.Open(m_sFilename, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyWrite))
	{	
		CString sError = _T("");
		sError.Format(_T("Failed CreateTmpFile: %d"), ::GetLastError());
		TRACE(_T("Failed CreateTmpFile: %s\n"), sError);
		//AfxMessageBox(sError);
		return ;
	}

	m_pImageDownloadThread = AfxBeginThread(_DownloadThread, this, THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED);
	if (m_pImageDownloadThread == NULL)
	{
		TRACE(_T("Failed to create download thread, dialog is aborting\n"));
		EndDialog(IDCANCEL);
		return ;
	}

	m_pImageDownloadThread->ResumeThread();
}

UINT CProfileDlg::_DownloadThread(LPVOID pParam)
{
	//Convert from the SDK world to the C++ world
	CProfileDlg* pDlg = (CProfileDlg*) pParam;
	ASSERT(pDlg);
	

	ASSERT(pDlg->IsKindOf(RUNTIME_CLASS(CProfileDlg)));

	if (pDlg == NULL)
		return 0;

	pDlg->DownloadThread();

	return 0;
}

bool CProfileDlg::IsCloseMsg(MSG* pMsg)
{
	bool result = false;
	if (pMsg->message == WM_CLOSE ||
		(pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4) ||									// ALT + F4
		(pMsg->message == WM_SYSCOMMAND && (pMsg->wParam & 0xFFF0) == SC_CLOSE) ||						// ŸƲ Ŭ޴ > ݱ
		(pMsg->message == WM_COMMAND && HIWORD(pMsg->wParam) == 0 && LOWORD(pMsg->wParam) == IDCANCEL))	// Close button
	{
		result = true;
	}

	return result;
}

void CProfileDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	m_nCursor = CURSOR_DEFAULT;

	if (GET_APP()->IsAvailableIPT())
	{
		for (int i = 0; i < PD_IPT_MAX; i++)
		{
			if (m_rtIPT[i].PtInRect(point) && (m_eIPTStatus == iptstIDLE || m_eIPTStatus == itpstHELD))
			{
				m_nCursor = CURSOR_HAND;
				return;
			}
		}
	}

	__super::OnMouseMove(nFlags, point);
}

BOOL CProfileDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	switch (m_nCursor)
	{
	case CURSOR_HAND:
		::SetCursor(m_hLinkCursor);
		return TRUE;
	}

	return __super::OnSetCursor(pWnd, nHitTest, message);
}

void CProfileDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	if( GET_APP()->IsAvailableIPT() )
	{
		CString strNumber = _T("");

		if (m_eIPTStatus == iptstIDLE || m_eIPTStatus == itpstHELD)
		{
			if (m_rtIPT[PD_IPT_EXT_TEL].PtInRect(point))
				m_editExttel.GetWindowText(strNumber);
			else if (m_rtIPT[PD_IPT_INCO_TEL].PtInRect(point))
				m_editTel.GetWindowText(strNumber);
			else if (m_rtIPT[PD_IPT_CELLPHONE].PtInRect(point))
				m_editMobile.GetWindowText(strNumber);

			if (!strNumber.IsEmpty())
				CallToIPT(strNumber);
		}	
	}
	__super::OnLButtonDown(nFlags, point);
}

void CProfileDlg::CallToIPT(CString strTel)
{
	if (strTel.IsEmpty())
		return;

	CDialPadManager* pManager = CDialPadManager::GetDialpadManager();

	if (pManager)
		pManager->MakeCall(m_userData, strTel);
}

void CProfileDlg::OnStnClickedParty1Static()
{
//	m_pProfileDlgController->CreateProfileDlg(m_strPartyID[0], CPoint(0, 0), NULL);
}

void CProfileDlg::OnStnClickedParty2Static()
{
//	m_pProfileDlgController->CreateProfileDlg(m_strPartyID[1], CPoint(0, 0), NULL);
}

void CProfileDlg::PostNcDestroy()
{
	__super::PostNcDestroy();

	delete this;
}
